%script corda di riferimento 

%implementa la corda di riferimento
n = 101;
m = ones(n,1)*0.01/n;
k = 1.0275e6*ones(n+1,1);
theta = 1.e-3;
q = 5;
y0 = zeros(n,1);
v0 = zeros(n,1);
for i=1:q
    y0(i)=i/q;
end
for i=q+1:n
    y0(i)=1-(i-q)/(n+1-q);
end
rate = 16384;
secs = 2;
pickup = 20; %Punto di campionamento

[s,v] = suonacorda(m, k, theta, y0, v0, rate, secs, pickup); 
%s = vettore di spostamenti del punto di pickup
%v = vettore di velocità del punto di pickup

%fft relative a s e v rispettivamente
f=fft(s);
g=fft(v);

%Grafico di spostamenti e velocità 
f1=figure(1); 
subplot(2,1,1)
plot(s(1:819));
title('Spostamenti');
subplot(2,1,2);
plot(v(1:819));
title('Velocità')
saveas(f1,'cordabase_sv.png');

%Grafico delle trasformate discrete di Fourier di spostamenti e velocità
f2=figure(2); 
subplot(2,1,1)
plot(abs(f(1:end/2))); title('Spostamenti'); subplot(2,1,2); plot(abs(g(1:end/2))); title('Velocità')
saveas(f2,'cordabase_Fourier.png');

%animazione
y = simula(m, k, theta, y0, v0, 40000, 15);

fanimator(@(t) anima(y{1},n, rate ,t),'AnimationRange',[0,1],'FrameRate',200) 
axis([1 n -1 1])

%playAnimation
%Decommentare per mettere in play l'animazione
writeAnimation('cordabase.avi') % Salva l'animazione come video su file
writeAnimation('cordabase.gif')